/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import static java.nio.charset.StandardCharsets.UTF_8;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author Edi
 */
@WebServlet(urlPatterns = {"/IO"})
public class Logic extends HttpServlet {

private ArrayList<Game> games = new ArrayList<>();

/**
 * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
 * methods.
 *
 * @param request servlet request
 * @param response servlet response
 * @throws ServletException if a servlet-specific error occurs
 * @throws IOException if an I/O error occurs
 */
String context = "";
String input = null;

@Override
public void init() {
try {
resetJSON();
} catch (FileNotFoundException ex) {
Logger.getLogger(Logic.class.getName()).log(Level.SEVERE, null, ex);
}
}

public void writeJSON(String s) throws Exception {
PrintWriter writer = new PrintWriter("game.JSON", "UTF-8");
if (s != null) {
writer.println(s);
}
writer.close();
}

public void resetJSON() throws FileNotFoundException {

File f = new File("game.JSON");

if (f.exists()) {
f.delete();
}

    try {
        writeJSON("{" +
                "\"room\": [{" +
                "\"id\": 0," +
                "\"name\": \"Keller\"," +
                "\"description\": \"Ein alter modriger Keller. <break time=\\\"1s\\\"/>  Es schimmelt überall und stinkt bestialisch. Vor dir liegt eine Leiche, im Raum steht ein Stuhl und ein Tisch. <break time=\\\"1s\\\"/>  Am anderen Ende des Raumes ist ein Duschvorhang an der Wand aufgespannt.\"," +
                "\"items\": [" +
                "5," +
                "7," +
                "4," +
                "0," +
                "2," +
                "6," +
                "10" +
                "]," +
                "\"puzzles\": [" +
                "9," +
                "4," +
                "0" +
                "]," +
                "\"gameoverFlag\": false" +
                "}," +
                "{" +
                "\"id\": 5," +
                "\"name\": \"Flur\"," +
                "\"description\": \"<audio src=\\\"soundbank://soundlibrary/footsteps/wood/wood_06\\\"/> Ein langer Flur. Hier lebt schon lange niemand mehr. Die Tapeten hängen von den Wänden runter. Der Boden knarzt und es stinkt nach Schimmel und verbranntem. <break time=\\\"1s\\\"/> Im Gang ist ein Koffer und eine Truhe zu sehen. Daneben befindet sich eine Tür.\"," +
                "\"items\": [" +
                "7," +
                "10" +
                "]," +
                "\"puzzles\": [" +
                "12," +
                "8," +
                "11," +
                "2" +
                "]," +
                "\"gameoverFlag\": false" +
                "}," +
                "{" +
                "\"id\": 1," +
                "\"name\": \"Erdgeschoss\"," +
                "\"description\": \"Ein komplett ausgebrannter Raum. An den Wänden ist überall Ruß. <break time=\\\"1s\\\"/> Im Eck steht ein Kamin der wird wohl Grund für den Brand sein. Eine Kommode und ein Eimer befinden sich noch im Raum.\"," +
                "\"items\": [" +
                "1," +
                "8," +
                "3," +
                "9" +
                "]," +
                "\"puzzles\": [" +
                "5," +
                "1," +
                "3" +
                "]," +
                "\"gameoverFlag\": false" +
                "}," +
                "{" +
                "\"id\": 2," +
                "\"name\": \"Wohnzimmer\"," +
                "\"description\": \"Ein eingestürzter Raum , hier hat das Feuer auch gewütet. Du kannst dich kaum bewegen.<break time=\\\"1s\\\"/> Es ist ein Fenster zu sehen von dem aus man raussehen kann und ein Wanddurchbruch der zugestellt ist.\"," +
                "\"puzzles\": [" +
                "7," +
                "6" +
                "]," +
                "\"gameoverFlag\": false" +
                "}" +
                "]," +
                "\"puzzle\": [{" +
                "\"id\": 9," +
                "\"name\": \"Schrank\"," +
                "\"description\": \"<audio src=\\\"soundbank://soundlibrary/doors/doors_wood/wood_07\\\"/> Ein wackliger alter Vitrinenschrank.\"," +
                "\"solvedText\": \"Leider nichts sinnvolles drin.\"," +
                "\"solved\": false," +
                "\"gameOverFlag\": false" +
                "}," +
                "{" +
                "\"id\": 4," +
                "\"name\": \"Duschvorhang\"," +
                "\"description\": \"Ein schimmliger vergilbter Duschvorhang, es wirkt so als ob etwas dahinter wäre. Er lässt sich öffnen.\"," +
                "\"solvedText\": \"Ja wohl, der Weg führt aus dem Zimmer raus <audio src=\\\"soundbank://soundlibrary/footsteps/wood/wood_06\\\"/> \"," +
                "\"nextRoom\": 1," +
                "\"solved\": false," +
                "\"gameOverFlag\": false" +
                "}," +
                "{" +
                "\"id\": 0," +
                "\"name\": \"Lederjacke\"," +
                "\"description\": \"Eine schwarze Lederjacke, Die Taschen sind leer, aber es ist irgendetwas im Saum, man sollte die Jacke mal öffnen.\"," +
                "\"solvedText\": \"Ein bisschen Kleingeld und eine Notiz mit einem Zugangscode. Du solltest beides mitnehmen man kann sicher etwas davon gebrauchen.\"," +
                "\"solved\": false," +
                "\"gameOverFlag\": false" +
                "}," +
                "{" +
                "\"id\": 3," +
                "\"name\": \"Tuer\"," +
                "\"description\": \"Eine Eisentür mit vielen Kerben. Sie ist voller Blut.\"," +
                "\"solvedText\": \"Eine Treppe ist hinter der Tür. Sie führt in einen anderen Raum.\"," +
                "\"dependencyText\": \"Du musst erst das Schloss öffnen das an der Tür hängt bevor du die Tür öffnen kannst.\"," +
                "\"dependency\": 11," +
                "\"nextRoom\": 2," +
                "\"solved\": false," +
                "\"gameOverFlag\": false" +
                "}," +
                "{" +
                "\"id\": 8," +
                "\"name\": \"Truhe\"," +
                "\"description\": \"Eine Werkzeugkist mit ein paar abgenutzten Werkzeugen <audio src=\\\"soundbank://soundlibrary/metal/metal_12\\\"/>\"," +
                "\"solvedText\": \"Du hast einen Schlüssel gefunden\"," +
                "\"solved\": false," +
                "\"gameOverFlag\": false" +
                "}," +
                "{" +
                "\"id\": 11," +
                "\"name\": \"Schloss\"," +
                "\"items\": [" +
                "10" +
                "]," +
                "\"description\": \"Ein massives elektronisches Metallschloss. \"," +
                "\"solvedText\": \"<audio src=\\\"soundbank://soundlibrary/doors/doors_metal/metal_02\\\"/> Jetzt kannst du die Tür öffnen\"," +
                "\"solved\": false," +
                "\"gameOverFlag\": false" +
                "}," +
                "{" +
                "\"id\": 2," +
                "\"name\": \"Koffer\"," +
                "\"description\": \"Ein abgenutzer Schalenkoffer mit aufgebrochenem Schloss\"," +
                "\"solvedText\": \"<audio src=\\\"soundbank://soundlibrary/home/amzn_sfx_door_open_02\\\"/> Ein paar Klamotten liegen darin. Vielleicht kann man damit etwas anfangen\"," +
                "\"solved\": false," +
                "\"gameOverFlag\": false" +
                "}," +
                "{" +
                "\"id\": 5," +
                "\"name\": \"Tor\"," +
                "\"items\": [" +
                "9," +
                "3" +
                "]," +
                "\"description\": \"Ein massives Stahltor . Das kriegt man mit bloßen Händen nicht auf\"," +
                "\"solvedText\": \"<audio src=\\\"soundbank://soundlibrary/doors/doors_metal/metal_01\\\"/> Mit dem Dietrich öffnest du geschickt das Schloss. Du öffnest die Tür einen leichten Spalt dann klemmst du den Stock rein und mit einem leichten Hebel kannst du die Tür komplett aufmachen.Ein rußiger Geruch steigt dir in die Nase, nachdem du durch die Tür gehst.\"," +
                "\"nextRoom\": 3," +
                "\"solved\": false," +
                "\"gameOverFlag\": false" +
                "}," +
                "{" +
                "\"id\": 1," +
                "\"name\": \"Kommode\"," +
                "\"description\": \"Eine hölzerne Kommode\"," +
                "\"solvedText\": \" <audio src=\\\"soundbank://soundlibrary/foley/amzn_sfx_wooden_door_creaks_long_01\\\"/> in den Schubladen findest du einen Stock. vielleicht ist er für etwas gut. Du solltest ihn mitnehmen.\"," +
                "\"solved\": false," +
                "\"gameOverFlag\": false" +
                "}," +
                "{" +
                "\"id\": 3," +
                "\"name\": \"Eiimer\"," +
                "\"description\": \"Ein Tretmülleimer. Er klemmt etwas man sollte ihn mal öffnen vielleicht findet man etwas nützliches.\"," +
                "\"solvedText\": \"<audio src=\\\"soundbank://soundlibrary/doors/doors_metal/metal_05\\\"/> Ein Dietrich. Den kann man sicher gut gebrauchen\"," +
                "\"solved\": false," +
                "\"gameOverFlag\": false" +
                "}," +
                "{" +
                "\"id\": 7," +
                "\"name\": \"Fenster\"," +
                "\"description\": \"Ein Fenster mit Gitterstäben davor. Vielleicht kann man es öffnen.\"," +
                "\"solvedText\": \"<audio src=\\\"soundbank://soundlibrary/metal/metal_10\\\"/> Leider sind die Gitterstäbe zu nah aneinander um sich durchzuzwängen. Du kannst aus dem Raum raus sehen. Vielleicht gibt es irgendwo eine Säge um die Stäbe durchzusägen.\"," +
                "\"solved\": false," +
                "\"gameOverFlag\": false" +
                "}," +
                "{" +
                "\"id\": 6," +
                "\"name\": \"Wanddurchbruch\"," +
                "\"description\": \"Ein Wanddurchbruch, durch einen kleinen Spalt kann man raussehen. Ein Wellblechdach versperrt den Ausgang. Versuche den Wanddurchbruch weiter zu öffnen. Dann bist du deinem Ziel näher\"," +
                "\"solvedText\": \"<audio src=\\\"soundbank://soundlibrary/human/amzn_sfx_human_walking_03\\\"/> Hurra. Du hast es Geschafft. Damit ist das Tutoriallevel beendet.\"," +
                "\"gameOverFlag\": true," +
                "\"solved\": false" +
                "}" +
                "]," +
                "\"item\": [{" +
                "\"id\": 6," +
                "\"name\": \"Karte\"," +
                "\"description\": \"Eine alte vergilbte Karte die am Tisch festgeklebt ist.\"," +
                "\"portableFlag\": false," +
                "\"hiddenFlag\": false" +
                "}," +
                "{" +
                "\"id\": 5," +
                "\"name\": \"Stuhl\"," +
                "\"description\": \"Ein klappriger alter Holzstuhl. Der ist zu nichts zu gebrauchen.\"," +
                "\"portableFlag\": false," +
                "\"hiddenFlag\": false" +
                "}," +
                "{" +
                "\"id\": 7," +
                "\"name\": \"Klamotten\"," +
                "\"portableFlag\": true," +
                "\"description\": \"Ein paar zerfranste alte Kleidungsstücke\"," +
                "\"hiddenFlag\": false" +
                "}," +
                "{" +
                "\"id\": 4," +
                "\"name\": \"Tisch\"," +
                "\"description\": \"Ein stabiler, massiver Holztisch. Zu schwer um ihn zu bewegen. Schade den hätte man sicher für etwas hernehmen können. Eine Karte klebt auf dem Tisch.\"," +
                "\"portableFlag\": false," +
                "\"hiddenFlag\": false" +
                "}," +
                "{" +
                "\"id\": 0," +
                "\"name\": \"Leiche\"," +
                "\"description\": \"Ein armer Kerl. Der liegt hier sicher schon seit Wochen. Er stinkt bestialisch. Vielleicht hat er in seiner Lederjacke etwas bei sich das dir hilft.\"," +
                "\"portableFlag\": false," +
                "\"hiddenFlag\": false" +
                "}," +
                "{" +
                "\"id\": 2," +
                "\"name\": \"Kleingeld\"," +
                "\"portableFlag\": true," +
                "\"description\": \"Etwas Kleingeld. Nicht der Rede Wert.\"," +
                "\"hiddenFlag\": false" +
                "}," +
                "{" +
                "\"id\": 10," +
                "\"name\": \"Zugangscode\"," +
                "\"portableFlag\": true," +
                "\"description\": \"Ein Zugangscode für ein elektronisches Scloss. Was der wohl öffnet?\"," +
                "\"hiddenFlag\": false" +
                "}," +
                "{" +
                "\"id\": 1," +
                "\"name\": \"Seil\"," +
                "\"portableFlag\": true," +
                "\"description\": \"Ein stabiles Seil, damit kann man sicher etwas festbinden oder irgendwo herunterklettern.\"," +
                "\"hiddenFlag\": false" +
                "}," +
                "{" +
                "\"id\": 8," +
                "\"name\": \"Kamin\"," +
                "\"description\": \"Ein verrußter Kamin, das ist sicher der Grund weshalb es hier gebrannt hat. Der Schonstein ist leider zu klein um hier raus zu kommen.\"," +
                "\"portableFlag\": false," +
                "\"hiddenFlag\": false" +
                "}," +
                "{" +
                "\"id\": 3," +
                "\"name\": \"Dietrich\"," +
                "\"portableFlag\": true," +
                "\"description\": \"Ein Dietrich, vielleicht öffnet er das ein oder andere Schloss\"," +
                "\"hiddenFlag\": false" +
                "}," +
                "{" +
                "\"id\": 9," +
                "\"name\": \"Stock\"," +
                "\"portableFlag\": true," +
                "\"description\": \"Ein stabiler Holzstock. Damit kann man sich vielleicht verteidigen\"," +
                "\"hiddenFlag\": false" +
                "}" +
                "]," +
                "\"story\": [" +
                "\"<audio src=\\\"soundbank://soundlibrary/household/lamps_lanterns/lamps_lanterns_02\\\"/> Du wachst auf, dir tut alles weh. Du hast Schmerzen dabei die Augen zu öffnen. Langsam gewöhnen sich deine Augen an das grelle Licht der Deckenleuchten. Wo bist du und wie bist du hier hergekommen. Es stinkt fürchterlich. Vor die liegt ein lebloser Körper, der Gestank kommt daher. Wenn du nicht so enden willst wie er solltest du hier schleunigst verschwinden\"" +
                "]" +
                "}");
    } catch (Exception ex) {
        Logger.getLogger(Logic.class.getName()).log(Level.SEVERE, null, ex);
    }


}

protected void processRequest(HttpServletRequest request, HttpServletResponse response)
throws ServletException, IOException, Exception {

try (PrintWriter out = response.getWriter()) {
/* TODO output your page here. You may use following sample code. */

if (request.getParameter("levelreset") != null) {
out.println("reset");
resetJSON();
}

if (request.getParameter("levelsubmit") != null) {
out.println("submit");
writeJSON(Arrays.toString(request.getParameterValues("levelsubmit")) + "");
}

if (request.getParameter("alexaText") != null) {
context = new String(request.getParameter("alexaText").getBytes(UTF_8));
}
// String deviceId = request.getParameter("deviceId");

out.println(context);

input = request.getParameter("intent");

if (request.getParameter("slot") != null) {
input = input + " " + request.getParameter("slot");
}

if (input != null) {
if (games.isEmpty()) {
games.add(new Game());
//games.add(new Game(deviceId));
}
/*
for(int i = 0; i < games.size(); i++)
{
if(games.get(i).getId() == deviceId)
{
games.get(i).setInput(input);
games.get(i).play();
}
}*/
games.get(0).setInput(input);
games.get(0).play();
}
}
}

// <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
/**
 * Handles the HTTP <code>GET</code> method.
 *
 * @param request servlet request
 * @param response servlet response
 * @throws ServletException if a servlet-specific error occurs
 * @throws IOException if an I/O error occurs
 */
@Override
protected void doGet(HttpServletRequest request, HttpServletResponse response)
throws ServletException, IOException {
response.setIntHeader("Refresh", 1);
try {
processRequest(request, response);

} catch (Exception ex) {
Logger.getLogger(Logic.class.getName()).log(Level.SEVERE, null, ex);
}
}

/**
 * Handles the HTTP <code>POST</code> method.
 *
 * @param request servlet request
 * @param response servlet response
 * @throws ServletException if a servlet-specific error occurs
 * @throws IOException if an I/O error occurs
 */
@Override
protected void doPost(HttpServletRequest request, HttpServletResponse response)
throws ServletException, IOException {
response.setIntHeader("Refresh", 1);
try {
processRequest(request, response);
} catch (Exception ex) {
Logger.getLogger(Logic.class.getName()).log(Level.SEVERE, null, ex);
}
}

/**
 * Returns a short description of the servlet.
 *
 * @return a String containing servlet description
 */
@Override
public String getServletInfo() {
return "Short description";
}// </editor-fold>

}
